# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------
# Name        :   Fastaair-L_Shape
# Author      :   Gilles TARNUS
# Contact     :   gta974@gmail.com
# Description :   A script to draw L shape Stair in 5 clicks
# Menu Item   :   2014 to now Extensions->Fastair-L_Shape
#                 until 2014 : Plugins->Fastair-L_Shape
# Usage       :   Select the tool: pick up origin of stair
#                 - pick up origin of stair
#                 - pick up the width of stair
#                 - pick up the low depth of stair
#                 - pick up the high depth of stair
#                 - pick up the high of stair
# Date        :   10/23/2015
# Type        :   tool
#-----------------------------------------------------------------------------

require 'sketchup.rb'

# Add a menu item to launch our plugin.

# UI.menu("Plugins").add_item("Fastair-L_Shape") {
  # Call function
    def pickUp
        Sketchup.active_model.select_tool Pick.new
    end
    # pickUp
# }

#contantes du modele
	mod = Sketchup.active_model # Open model
	ent = mod.entities # All entities in model
	sel = mod.selection # Current selection
    
#Unité et valeurs d'entree
	if Sketchup.active_model.options["UnitsOptions"]["LengthUnit"] > 1
        $unit = 25.4
    else 
        $unit = 25.4
	end

class Pick###

def getExtents
    bbox=Sketchup.active_model.bounds
    bbox.add(@ip.position)if @ip and @ip.valid?
    bbox.add(@ip1.position)if @ip1 and @ip1.valid?
    bbox.add(@ip2.position)if @ip2 and @ip2.valid?
    bbox.add(@ip3.position)if @ip3 and @ip3.valid?
    bbox.add(@ip4.position)if @ip4 and @ip4.valid?
    bbox.add(@ip5.position)if @ip5 and @ip5.valid?
    return bbox
end # def getExtents

def initialize
    @ss = Sketchup.active_model.selection
    @ip1 = nil
    @ip2 = nil
    @ip3 = nil
    @ip4 = nil
    @ip5 = nil
    @xdown = 0
    @ydown = 0
end # def initialize

def activate
    @ip1 = Sketchup::InputPoint.new
    @ip2 = Sketchup::InputPoint.new
    @ip3 = Sketchup::InputPoint.new
    @ip4 = Sketchup::InputPoint.new
    @ip5 = Sketchup::InputPoint.new
    @ip = Sketchup::InputPoint.new
    @drawn = false
    
    self.reset(nil)
end # def activate

def deactivate(view)
    view.invalidate if @drawn
end # def deactivate

def onMouseMove(flags, x, y, view)
    if( @state == 0 )
       
        @ip.pick view, x, y
        if( @ip != @ip1 )
            view.invalidate if( @ip.display? or @ip1.display? )
            @ip1.copy! @ip
            view.tooltip = @ip1.tooltip
        end
    elsif( @state == 1 )
        @ip2.pick view, x, y, @ip1
        view.tooltip = @ip2.tooltip if( @ip2.valid? )
        view.invalidate
        
        if( @ip2.valid? )
            length = @ip1.position.distance(@ip2.position)
            Sketchup::set_status_text length.to_s, SB_VCB_VALUE
        end
        
        if( (x-@xdown).abs > 10 || (y-@ydown).abs > 10 )
            @dragging = true
        end
    elsif( @state == 2 )
        @ip3.pick view, x, y, @ip2
        view.tooltip = @ip3.tooltip if( @ip3.valid? )
        view.invalidate
        
        if( @ip3.valid? )
            length = @ip2.position.distance(@ip3.position)
            Sketchup::set_status_text length.to_s, SB_VCB_VALUE
        end
        
        if( (x-@xdown).abs > 10 || (y-@ydown).abs > 10 )
            @dragging = true
        end
    elsif( @state == 3 )
        @ip4.pick view, x, y, @ip3
        view.tooltip = @ip4.tooltip if( @ip4.valid? )
        view.invalidate
        
        if( @ip4.valid? )
            length = @ip3.position.distance(@ip4.position)
            Sketchup::set_status_text length.to_s, SB_VCB_VALUE
        end
        
        if( (x-@xdown).abs > 10 || (y-@ydown).abs > 10 )
            @dragging = true
        end
    else
        @ip5.pick view, x, y, @ip4
        view.tooltip = @ip5.tooltip if( @ip5.valid? )
        view.invalidate
        
        if( @ip5.valid? )
            length = @ip4.position.distance(@ip5.position)
            Sketchup::set_status_text length.to_s, SB_VCB_VALUE
        end
        
        if( (x-@xdown).abs > 10 || (y-@ydown).abs > 10 )
            @dragging = true
        end
    end
end # def onMouseMove

def onLButtonDown(flags, x, y, view)
    if( @state == 0 )
        @ip1.pick view, x, y
        if( @ip1.valid? )
            @state = 1
            Sketchup::set_status_text "FaStair: Second Point to define width", SB_PROMPT
            @xdown = x
            @ydown = y
        end
    elsif( @state == 1 )
        # @ip2.pick view, x, y
        if( @ip2.valid? )
            @state = 2
            Sketchup::set_status_text "FaStair: 3th Point to define depth", SB_PROMPT
            @xdown = x
            @ydown = y
        end
    elsif( @state == 2 )
        # @ip2.pick view, x, y
        if( @ip3.valid? )
            @state = 3
            Sketchup::set_status_text "FaStair: 4th Point to define height", SB_PROMPT
            @xdown = x
            @ydown = y
        end
    elsif( @state == 3 )
                # @ip2.pick view, x, y
        if( @ip4.valid? )
            @state = 4
            Sketchup::set_status_text "FaStair: 4th Point to define height", SB_PROMPT
            @xdown = x
            @ydown = y
        end
    else
        self.get_pts(@ip1.position, @ip2.position, @ip3.position, @ip4.position, @ip5.position, view)
        self.reset(view)
    end
    
    view.lock_inference
end # def onLButtonDown

def onKeyDown(key, repeat, flags, view)
    if( key == CONSTRAIN_MODIFIER_KEY && repeat == 1 )
        @shift_down_time = Time.now
        if( view.inference_locked? )
            view.lock_inference
        elsif( @state == 0 && @ip1.valid? )
            view.lock_inference @ip1
        elsif( @state == 1 && @ip2.valid? )
            view.lock_inference @ip2, @ip1
        elsif( @state == 2 && @ip3.valid? )
            view.lock_inference @ip3, @ip2
        elsif( @state == 3 && @ip4.valid? )
            view.lock_inference @ip4, @ip3
        elsif( @state == 4 && @ip5.valid? )
            view.lock_inference @ip5, @ip4
        end
    end
end # def onKeyDown

def onKeyUp(key, repeat, flags, view)
    if( key == CONSTRAIN_MODIFIER_KEY &&
        view.inference_locked? &&
        (Time.now - @shift_down_time) > 0.5 )
        view.lock_inference
    end
end # def onKeyUp

def draw(view)
    if( @ip1.valid? )
        if( @ip1.display? )
            @ip1.draw(view)
            @drawn = true
            view.draw_points @ip1.position, 8, 1, "black"
        end
        
        if( @ip2.valid? )
            @ip2.draw(view) if( @ip2.display? )
            
            view.set_color_from_line(@ip1, @ip2)
            self.draw_geometry(@ip1.position, @ip2.position, view)
            @drawn = true
        end
        if( @ip3.valid? )
            @ip3.draw(view) if( @ip3.display? )
            
            view.set_color_from_line(@ip2, @ip3)
            self.draw_geometry(@ip2.position, @ip3.position, view)
            @drawn = true
        end
        if( @ip4.valid? )
            @ip4.draw(view) if( @ip4.display? )
            
            view.set_color_from_line(@ip3, @ip4)
            self.draw_geometry(@ip3.position, @ip4.position, view)
            @drawn = true
        end
        if( @ip5.valid? )
            @ip5.draw(view) if( @ip5.display? )
            
            view.set_color_from_line(@ip4, @ip5)
            self.draw_geometry(@ip4.position, @ip5.position, view)
            @drawn = true
        end
    end
    view.draw_points @ip2.position, 8, 1, "black"
    view.draw_points @ip3.position, 10, 1, "red"
    view.draw_points @ip4.position, 10, 1, "blue"
    view.draw_points @ip5.position, 10, 1, "blue"
end # def draw

# onCancel is called when the user hits the escape key
def onCancel(flag, view)
    self.reset(view)
end # def onCancel


# Reset the tool back to its initial state
def reset(view)
    @state = 0
    Sketchup::set_status_text("FaStair: First Point to define origine", SB_PROMPT)
    @ip1.clear
    @ip2.clear
    @ip3.clear
    @ip4.clear
    @ip5.clear
    
    if( view )
        view.tooltip = nil
        view.invalidate if @drawn
    end
    
    @drawn = false
    @dragging = false
end # def reset

# Draw the geometry
def draw_geometry(pt1, pt2, view)
    view.draw_line(pt1, pt2)
end # def draw_geometry

def get_pts(p1, p2, p3, p4, p5, view)
    $point1 = Geom::Point3d.new(p1)
    $point2 = Geom::Point3d.new(p2)
    $point3 = Geom::Point3d.new(p3)
    if $point3.z != $point2.z
       $point3.z = $point2.z
    end
    $point4 = Geom::Point3d.new(p4)
    if $point4.z != $point3.z
       $point4.z = $point3.z
    end
    $point5 = Geom::Point3d.new(p5)
    a = Define_points.new
end # def get_pts

end # Class Pick

class Define_points###

def initialize
    determination_caracterisques
    if @drawn == true 
        dessin_escalier
    end
end # def initialize

def determination_caracterisques
        vecteur_hauteur_totale = $point5 - $point4
        hauteur_totale = vecteur_hauteur_totale.length
        vecteur_longueur_totale_low = $point3 - $point2
        longueur_totale_low = vecteur_longueur_totale_low.length
        vecteur_longueur_totale_high = $point4 - $point3 #
        longueur_totale_high = vecteur_longueur_totale_high.length #
        vecteur_largeur = $point2 - $point1
        largeur = vecteur_largeur.length
        @largeur = largeur
        angle_tourne = vecteur_longueur_totale_low.angle_between vecteur_longueur_totale_high
        # puts angle_tourne * 180 / Math::PI
        rayon_jour = 200 / $unit
        if largeur > 1000 / 25.4
            largeur_foulee = 500 / 25.4
        else
            largeur_foulee = largeur / 2
        end
        
        # sens_plan_zero 
        sens_plan_zero = (vecteur_longueur_totale_low.cross vecteur_longueur_totale_high).dot Geom::Vector3d.new 0,0,1
        if sens_plan_zero < 0
            @sens_plan_zero = -1
        else
            @sens_plan_zero = 1
        end
    
    @nombre_de_marches = 1

    longueur_totale_low = vecteur_longueur_totale_low.length
    @hauteur_de_marche = hauteur_totale * $unit / @nombre_de_marches
        
    # optimisation de la hauteur de marche 
    i = 1
    if hauteur_totale > 2 * 160 / $unit
        @drawn = true
        while ( @hauteur_de_marche > 180 or @hauteur_de_marche < 160 )
            if @hauteur_de_marche > 180
                @nombre_de_marches = @nombre_de_marches + 1
            elsif @hauteur_de_marche < 160 # and @nombre_de_marches > 1
                @nombre_de_marches = @nombre_de_marches - 1
            else
                break
            end
            # puts @nombre_de_marches
            @hauteur_de_marche = hauteur_totale * 25.4 / @nombre_de_marches
            i += 1
            if i > 100
                break
            end
        end
    else
        UI.messagebox("Stair is not high enough")
        @drawn = false
    end
   
    # Virage 
    giron = 640 - ( 2 * @hauteur_de_marche)
    @angle_tourne_unitaire = 2 * angle_from_3_points([((largeur_foulee + rayon_jour)**2 - ( giron / $unit / 2 )**2 )**0.5, 0, 0], [0,0,0], [((largeur_foulee + rayon_jour)**2 - ( giron / $unit / 2 )**2 )**0.5, - giron / $unit / 2 ,0])
    # puts @angle_tourne_unitaire * 180 / 3.14
    
    @nombre_marches_tournes = ( angle_tourne / @angle_tourne_unitaire ).round
    # if angle_tourne < @angle_tourne_unitaire * @nombre_marches_tournes
        @balance_first_high = true
    # else
        # @balance_first_high = false
    # end
    angle_restant = angle_tourne - @angle_tourne_unitaire * @nombre_marches_tournes
    nombre_de_marches_restante = @nombre_de_marches - @nombre_marches_tournes
    @nombre_de_marches_low = (( longueur_totale_low - largeur  ) / ( giron / $unit )).floor
    if @nombre_de_marches_low < 0
        @nombre_de_marches_low = 0
    end
    @nombre_de_marches_high = nombre_de_marches_restante - @nombre_de_marches_low
    if longueur_totale_high - largeur < ( giron / $unit )
        @nombre_de_marches_low = @nombre_de_marches_low + @nombre_de_marches_high
        @nombre_de_marches_high = 0
    end
    # UI.messagebox("nombre de marche en bas : " + @nombre_de_marches_low.to_s + "\nnombre de marche tournee = " + @nombre_marches_tournes.to_s + "\nnombre de marche en haut = " + @nombre_de_marches_high.to_s + "\npour un total de = " + @nombre_de_marches.to_s)
    
    
    # Vecteur unitaire :
    vecteur_giron_unitaire_low = vecteur_longueur_totale_low.normalize
    vecteur_giron_unitaire_high = vecteur_longueur_totale_high.normalize
    @vecteur_decalage_profondeur = vecteur_longueur_totale_low.normalize
    @vecteur_decalage_profondeur.length = longueur_totale_low - giron / $unit * @nombre_de_marches_low - largeur - rayon_jour
    vecteur_largeur_unitaire = vecteur_largeur.normalize
    vecteur_hauteur_unitaire = vecteur_hauteur_totale.normalize

    # Vecteur entier :
    @vecteur_giron_entier_low = vecteur_giron_unitaire_low.clone
    @vecteur_giron_entier_low.length = giron / $unit
    @vecteur_giron_entier_high = vecteur_giron_unitaire_high.clone
    @vecteur_giron_entier_high.length = giron / $unit
    @vecteur_largeur_entier_low = vecteur_largeur_unitaire.clone
    @vecteur_largeur_entier_low.length = largeur
    @vecteur_largeur_foulee = vecteur_largeur_unitaire.clone
    @vecteur_largeur_foulee.length = largeur_foulee
    @vecteur_hauteur_entier = vecteur_hauteur_unitaire.clone
    @vecteur_hauteur_entier.length = @hauteur_de_marche / $unit
    @vecteur_largeur_foulee_high = vecteur_largeur_unitaire.clone
    @vecteur_largeur_foulee_high.length = largeur_foulee
    rotate_angle_escalier =  Geom::Transformation.rotation [0,0,0], [0,0,1], angle_tourne
    @vecteur_largeur_foulee_high.transform! rotate_angle_escalier
    @vecteur_largeur_foulee_high_unitaire = @vecteur_largeur_foulee_high.normalize
    @vecteur_largeur_entier_high = @vecteur_largeur_entier_low.clone
    @vecteur_largeur_entier_high.transform! rotate_angle_escalier
    # @vecteur_largeur_entier_high.length = @vecteur_largeur_entier_high
    
    # puts @vecteur_largeur_foulee_high.length

    # Plans limites
    @plan_droit = [$point1, vecteur_largeur_unitaire]
    @plan_gauche = [$point2, vecteur_largeur_unitaire.reverse]
    point_interieur = $point3.clone
    # puts @sens_plan_zero
    if @sens_plan_zero < 0
        point_interieur.offset! @vecteur_largeur_entier_high
    else
        point_interieur.offset! @vecteur_largeur_entier_high.reverse
    end
    @plan_avant = [point_interieur, @vecteur_largeur_foulee_high_unitaire.reverse] #
    @plan_arriere = [$point3, @vecteur_largeur_foulee_high_unitaire] #
    
end # def determination_caracterisques

def dessin_escalier
    # Creation des points / faces et du groupe
        pt0 = Geom::Point3d.new
        pt0 = $point1.offset @vecteur_largeur_foulee
        pt0 = pt0.offset @vecteur_decalage_profondeur
        @stair = Sketchup.active_model.entities.add_group
        @stair_line = Sketchup.active_model.entities.add_group
        @stair_tournant = Sketchup.active_model.entities.add_group
        
    # Creation des marches droites du debut
        # on balance l escalier
        perpendiculaire =  Geom::Transformation.rotation [0,0,0], [0,0,1], -( Math::PI) / 2
        vecteur_giron_balance_low = @vecteur_giron_entier_low.clone
        @vecteur_rayonnant_balance_low = vecteur_giron_balance_low.clone
        @vecteur_rayonnant_balance_low.transform! perpendiculaire
        transformation_tournant = Geom::Transformation.rotation [0,0,0], [0,0,1], ( ( @angle_tourne_unitaire * @sens_plan_zero) / (4))
        # @vecteur_rayonnant11 = @vecteur_rayonnant1.clone
        @vecteur_rayonnant_balance_low.transform! transformation_tournant

        for i in 1..@nombre_de_marches_low
        
        pt1 = pt0.offset @vecteur_hauteur_entier 
        pt2 = pt1.offset @vecteur_giron_entier_low
        
        if i == @nombre_de_marches_low
            points = project_points_to_stairwell(pt0, pt1, pt2, @plan_gauche, @plan_arriere, @plan_droit, @plan_avant, @vecteur_largeur_foulee, @vecteur_rayonnant_balance_low, true)
        else
            points = project_points_to_stairwell(pt0, pt1, pt2, @plan_gauche, @plan_arriere, @plan_droit, @plan_avant, @vecteur_largeur_foulee, @vecteur_largeur_foulee, false)
        end
        plan_vertical = points[0]
        plan_horizontal = points[1]
        @stair.entities.add_face plan_vertical
        @stair.entities.add_face plan_horizontal

        @stair_line.entities.add_line pt0, pt1
        @stair_line.entities.add_line pt1, pt2
        
        pt0.offset! @vecteur_hauteur_entier
        pt0.offset! @vecteur_giron_entier_low
        
        end
        
        vecteur_giron_tournant = @vecteur_giron_entier_low.clone
        
# Creation des marches tournees
        perpendiculaire =  Geom::Transformation.rotation [0,0,0], [0,0,1], -( Math::PI) / 2
        # on tourne de - angle pour le debut
        @vecteur_rayonnant1 = vecteur_giron_tournant.clone
        @vecteur_rayonnant1.transform! perpendiculaire
        transformation_tournant = Geom::Transformation.rotation [0,0,0], [0,0,1], ( ( -@angle_tourne_unitaire * @sens_plan_zero) / (2))
        @vecteur_rayonnant11 = @vecteur_rayonnant1.clone
        vecteur_tourne = vecteur_giron_tournant.transform! transformation_tournant
        for i in 1..@nombre_marches_tournes
        $points_horizontaux = []
        $points_verticaux = []
        
        @vecteur_rayonnant1 = vecteur_giron_tournant.clone
        @vecteur_rayonnant1.transform! perpendiculaire
        transformation_tournant = Geom::Transformation.rotation [0,0,0], [0,0,1], ( ( @angle_tourne_unitaire * @sens_plan_zero))
        vecteur_tourne = vecteur_giron_tournant.transform! transformation_tournant
        @vecteur_rayonnant2 = vecteur_tourne.clone
        @vecteur_rayonnant2.transform! perpendiculaire
            
        pt1 = pt0.offset @vecteur_hauteur_entier 
        pt2 = pt1.offset vecteur_tourne
        points = [pt0, pt1, pt2]
        
        if i == 1
            points = project_points_to_stairwell(pt0, pt1, pt2, @plan_gauche, @plan_arriere, @plan_droit, @plan_avant, @vecteur_rayonnant_balance_low, @vecteur_rayonnant2, true)
        else
            points = project_points_to_stairwell(pt0, pt1, pt2, @plan_gauche, @plan_arriere, @plan_droit, @plan_avant, @vecteur_rayonnant1, @vecteur_rayonnant2, true)
        end
        plan_vertical = points[0]#[points[0], points[1], points[4], points[3]] 
        plan_horizontal = points[1]#[points[1], points[2], points[5], points[4]] 
        @stair.entities.add_face plan_vertical
        @stair.entities.add_face plan_horizontal
        @stair.entities.add_face plan_vertical
        @stair.entities.add_face plan_horizontal
        @stair_line.entities.add_line pt0, pt1
        @stair_line.entities.add_line pt1, pt2
        
        pt0 = pt2
        end
                    
    # Creation des marches droites de la fin
    # puts 'Creation des marches droites de la fin'

        for i in 1..@nombre_de_marches_high
        
        points_horizontaux = []
        points_verticaux = []
        
        pt1 = pt0.offset @vecteur_hauteur_entier 
        pt2 = pt1.offset @vecteur_giron_entier_high
    
        # pt0.offset! @vecteur_hauteur_entier
        # pt0.offset! @vecteur_giron_entier_low
        
        if @balance_first_high == true and i == 1
            points = project_points_to_stairwell(pt0, pt1, pt2, @plan_gauche, @plan_arriere, @plan_droit, @plan_avant, @vecteur_rayonnant2, @vecteur_largeur_foulee_high, true)
        else
            points = project_points_to_stairwell(pt0, pt1, pt2, @plan_gauche, @plan_arriere, @plan_droit, @plan_avant, @vecteur_largeur_foulee_high, @vecteur_largeur_foulee_high, false)
        end
        
        plan_vertical = points[0]#[points[0], points[1], points[4], points[3]] 
        plan_horizontal = points[1]#[points[1], points[2], points[5], points[4]] 
        
            if i != @nombre_de_marches_high
                @stair.entities.add_face plan_vertical
                @stair.entities.add_face plan_horizontal
                @stair_line.entities.add_line pt0, pt1
                @stair_line.entities.add_line pt1, pt2
            else
                @stair_line.entities.add_line pt0, pt1
                @stair.entities.add_face plan_vertical
            end
        
        pt0.offset! @vecteur_hauteur_entier
        pt0.offset! @vecteur_giron_entier_high
        end
        
end # def dessin_escalier

def project_to_plane_from_vector(point, vector, plane)
    """Cette fonction projete un point sur un plan
    le long d un vecteur, n existe pas en natif"""
    distance = point.distance_to_plane plane
    vecteur_normal_plan = plane[1]
    distance = distance / Math.cos(vector.angle_between vecteur_normal_plan)
    if distance > 10 * @largeur
        point_projected = nil
    else
    vector_unitaire = (vector.clone).normalize
    vector_offset = vector_unitaire.clone
    echelle_vecteur = Geom::Transformation.scaling distance
    vector_offset.transform! echelle_vecteur
    point_projected = point.offset vector_offset
    status = point_projected.on_plane? plane
    # puts status
    if status == false
        echelle_vecteur = Geom::Transformation.scaling -1
        vector_offset.transform! echelle_vecteur
        point_projected = point.offset vector_offset
        status = point_projected.on_plane? plane
        # puts "reverse"
    end
    status = point_projected.on_plane? plane
    if status == false
        puts ("Probleme de projection parallele ?")
        point_projected = nil
    end
    return point_projected
    end
end
    
def project_on_corner_horizontal(p1, p2, plan1, vector)
    '''Cette fonction definie la forme des marches dans l angle tournant '''
    list = []
    # UI.messagebox("debut de projection list = "+list.to_s)
    p13 = p1.project_to_plane plan1
    v1_2 = p2 - p1
    v1_13 = p13 - p1
    if v1_13.length < v1_2.length
        list = list + [p1]
        list = list + [p13]
        # list = list + [p2]
        p31 = project_to_plane_from_vector(p2, vector, plan1)
        list = list + [p31]
        # list = list + [p2]
    # UI.messagebox("match "+v1_13.length.to_s+v1_2.length.to_s)
    else
        list = list + [p1]
        list = list + [p2]
        # UI.messagebox("not match "+v1_13.length.to_s+v1_2.length.to_s)
    end
    # UI.messagebox("fin de projection list = "+list[1].to_s)
    return list
end

def project_on_corner(plan_ext, plan_int, vector1, vector2, plan_vertical, plan_horizontal)
    '''Cette fonction definie la forme des marches dans l angle tournant '''
    # plan_vertical = [points[0], points[1], points[4], points[3]] 
    # plan_horizontal = [points[1], points[2], points[5], points[4]]
    # plan_vertical[0] = point_vertical0
    # plan_vertical[1] = point_vertical1
    # plan_vertical[2] = point_vertical2
    # plan_vertical[3] = point_vertical3
    point_vertical0 = plan_vertical[0]
    point_vertical1 = plan_vertical[1]
    point_vertical2 = plan_vertical[2]
    point_vertical3 = plan_vertical[3]
    
    # plan_horizontal[0] = point_horizontal0
    # plan_horizontal[1] = point_horizontal1
    # plan_horizontal[2] = point_horizontal2
    # plan_horizontal[3] = point_horizontal3
    point_horizontal0 = plan_horizontal[0]
    point_horizontal1 = plan_horizontal[1]
    point_horizontal2 = plan_horizontal[2]
    point_horizontal3 = plan_horizontal[3]
    
    # puts 'coucou, c\'est nous'
    
    # ici on resout le probleme du coin exterieur
    if (point_horizontal2.on_plane? plan_ext[1] and point_horizontal3.on_plane? plan_ext[0]) #or (point_vertical0.on_plane? plane_int[0] and point_vertical1.on_plane? plane_int[1])
        point_horizontal23 = point_horizontal2.project_to_plane plan_ext[0]
        plan_horizontal[0] = point_horizontal0
        plan_horizontal[1] = point_horizontal1
        plan_horizontal[2] = point_horizontal2
        plan_horizontal[3] = point_horizontal23
        plan_horizontal[4] = point_horizontal3
    end
    
    # ici s occupe des points interieurs
    ## d abord les points horizontaux
    vec01 = point_horizontal1 - point_horizontal0
    
    if (point_horizontal0.on_plane? plan_int[0]) == true and !(project_to_plane_from_vector(point_horizontal0, vector1, plan_int[1]).nil?)
        # puts 1
        point_horizontal0a = project_to_plane_from_vector(point_horizontal0, vector1, plan_int[1])
    elsif (point_horizontal0.on_plane? plan_int[1]) == true and !(project_to_plane_from_vector(point_horizontal0, vector1, plan_int[0]).nil?)
        # puts 2
        point_horizontal0a = project_to_plane_from_vector(point_horizontal0, vector1, plan_int[0])
    else
        point_horizontal0a = point_horizontal0
        # puts 3
    end
    
    if (point_horizontal1.on_plane? plan_int[0]) == true and !(project_to_plane_from_vector(point_horizontal1, vector2, plan_int[1]).nil?)
        point_horizontal1a = project_to_plane_from_vector(point_horizontal1, vector2, plan_int[1])
        # puts 4
    elsif (point_horizontal1.on_plane? plan_int[1]) == true and !(project_to_plane_from_vector(point_horizontal1, vector2, plan_int[0]).nil?)
        point_horizontal1a = project_to_plane_from_vector(point_horizontal1, vector2, plan_int[0])
        # puts 5
    else
        point_horizontal1a = point_horizontal1
        # puts 6
    end
    
    # puts point_horizontal0a
    # puts point_horizontal1a
    
    vec0a1a = point_horizontal1a - point_horizontal0a
    vec01a = point_horizontal1a - point_horizontal0
    vec0a1 = point_horizontal1 - point_horizontal0a
    if vec0a1a.length < vec01.length
        # puts 1
        plan_horizontal[0] = point_horizontal0a
        plan_horizontal[1] = point_horizontal1a
    elsif vec01a.length < vec01.length
        # puts 2
        plan_horizontal[0] = point_horizontal0
        plan_horizontal[1] = point_horizontal1a
   elsif vec0a1.length < vec01.length
        # puts 3
        plan_horizontal[0] = point_horizontal0a
        plan_horizontal[1] = point_horizontal1
    end

    vec01 = plan_horizontal[1] - plan_horizontal[0]
    
    vecteur_origine_point_horizontal1 = plan_horizontal[1] - $point1
    vecteur_origine_point_horizontal1.z = 0
    point_coin_bas = $point1.project_to_plane plan_int[1]
    vec_coin = point_coin_bas - $point1
    if vecteur_origine_point_horizontal1.length > vec_coin.length and plan_horizontal[0].on_plane? plan_int[0] and plan_horizontal[1].on_plane? plan_int[0]# si le point est en dehors de la zone de plan int
        puts 4
        point_horizontal01 = plan_horizontal[0].project_to_plane plan_int[1]
        plan_horizontal[2] = project_to_plane_from_vector(plan_horizontal[2], vector2, plan_int[1])
        plan_horizontal[0] = plan_horizontal[0]
        plan_horizontal[1] = point_horizontal01
        plan_horizontal[3] = point_horizontal2
        plan_horizontal[4] = point_horizontal3
    elsif (plan_horizontal[0].on_plane? plan_int[0] and plan_horizontal[1].on_plane? plan_int[1])or (plan_horizontal[0].on_plane? plan_int[1] and plan_horizontal[1].on_plane? plan_int[0])
    # puts 'coucou'
        plan_horizontal[0] = project_to_plane_from_vector(plan_horizontal[0], vector1, plan_int[0])
        point_horizontal01 = plan_horizontal[0].project_to_plane plan_int[1]
        plan_horizontal[1] = point_horizontal01
        plan_horizontal[2] = project_to_plane_from_vector(plan_horizontal[2], vector2, plan_int[1])
        plan_horizontal[3] = point_horizontal2
        plan_horizontal[4] = point_horizontal3
    end
    
    
    plan_vertical[0].x = plan_horizontal[0].x
    plan_vertical[0].y = plan_horizontal[0].y
    plan_vertical[1] = plan_horizontal[0]
    return plan_vertical, plan_horizontal
end

def angle_from_3_points(p1, p2, p3)
    p1 = Geom::Point3d.new p1
    p2 = Geom::Point3d.new p2
    p3 = Geom::Point3d.new p3
    v21 = p1 - p2
    v23 = p3 - p2
    angle = v21.angle_between v23
    return angle
end

def project_points_to_stairwell(p1, p2, p3, plane1, plane2, plane3, plane4, vector1, vector2, check_corner)
    '''projete la ligne de foulee sur la cage d escalier
    retourne 2 listes, liste de points pour la surface horizontale
    et liste de points pour la surface verticale'''
    
    plan_ext = [plane1, plane2]
    plan_int = [plane3, plane4]
    vector = [vector1, vector2]
    pts = [p1, p2, p3]
    #projection sur l interieur de la cage
    points_interieurs_retenus = []
    points_interieurs_proposition1 = []
    points_interieurs_proposition2 = []
    for j in 0..(pts.length - 1)
    # puts 'debut des points interieurs'
    # puts 'j = '+j.to_s
        for i in 0..(plan_int.length - 1)
            # puts 'i = '+i.to_s
            if i == 0
                if j < 2
                    a = project_to_plane_from_vector(pts[j], vector1, plan_int[i])
                    points_interieurs_proposition1 = points_interieurs_proposition1 + [a]
                else
                    a = project_to_plane_from_vector(pts[j], vector2, plan_int[i])
                    points_interieurs_proposition1 = points_interieurs_proposition1 + [a]
                end
            else
                if j < 2
                    a = project_to_plane_from_vector(pts[j], vector1, plan_int[i])
                    points_interieurs_proposition2 = points_interieurs_proposition2 + [a]
                else
                    a = project_to_plane_from_vector(pts[j], vector2, plan_int[i])
                    points_interieurs_proposition2 = points_interieurs_proposition2 + [a]
                end
            end
        # puts 'fin de boucle plan '+i.to_s+' et du point '+j.to_s+', a = '+a.to_s
        end
    # puts 'fin de boucle points '+j.to_s
    # puts 'fin des points interieurs'
    end
    # puts points_interieurs_proposition1
    # puts points_interieurs_proposition2
    
    # Choix des points interieurs
    for i in 0..points_interieurs_proposition1.length - 1
    # puts i
        if !points_interieurs_proposition1[i].nil? and !points_interieurs_proposition2[i].nil?
            longueur1 = (pts[i] - points_interieurs_proposition1[i]).length
            longueur2 = (pts[i] - points_interieurs_proposition2[i]).length
            if longueur1 < longueur2
                points_interieurs_retenus[i] = points_interieurs_proposition1[i]
            else
                points_interieurs_retenus[i] = points_interieurs_proposition2[i]
            end
        elsif !points_interieurs_proposition1[i].nil?
            points_interieurs_retenus[i] = points_interieurs_proposition1[i]
        elsif !points_interieurs_proposition2[i].nil?
            points_interieurs_retenus[i] = points_interieurs_proposition2[i]
        else
            points_interieurs_retenus[i] = 'point pourrave'
        end
    end
    # puts points_interieurs_retenus
    
    #projection sur l exterieur de la cage
    points_exterieurs_retenus = []
    points_exterieurs_proposition1 = []
    points_exterieurs_proposition2 = []
    for j in 0..(pts.length - 1)
    # puts 'debut des points exterieurs'
    # puts 'j = '+j.to_s
        for i in 0..(plan_int.length - 1)
            # puts 'i = '+i.to_s
            if i == 0
                if j < 2
                    a = project_to_plane_from_vector(pts[j], vector1, plan_ext[i])
                    points_exterieurs_proposition1 = points_exterieurs_proposition1 + [a]
                else
                    a = project_to_plane_from_vector(pts[j], vector2, plan_ext[i])
                    points_exterieurs_proposition1 = points_exterieurs_proposition1 + [a]
                end
            else
                if j < 2
                    a = project_to_plane_from_vector(pts[j], vector1, plan_ext[i])
                    points_exterieurs_proposition2 = points_exterieurs_proposition2 + [a]
                else
                    a = project_to_plane_from_vector(pts[j], vector2, plan_ext[i])
                    points_exterieurs_proposition2 = points_exterieurs_proposition2 + [a]
                end
            end
        # puts 'fin de boucle plan '+i.to_s+' et du point '+j.to_s+', a = '+a.to_s
        end
    # puts 'fin de boucle points '+j.to_s
    # puts 'fin des points exterieurs'
    end
    
    #Choix des points
    for i in 0..points_exterieurs_proposition1.length - 1
    # puts i
        if !points_exterieurs_proposition1[i].nil? and !points_exterieurs_proposition2[i].nil?
            longueur1 = (pts[i] - points_exterieurs_proposition1[i]).length
            longueur2 = (pts[i] - points_exterieurs_proposition2[i]).length
            if longueur1 < longueur2
                points_exterieurs_retenus[i] = points_exterieurs_proposition1[i]
            else
                points_exterieurs_retenus[i] = points_exterieurs_proposition2[i]
            end
        elsif !points_exterieurs_proposition1[i].nil?
            points_exterieurs_retenus[i] = points_exterieurs_proposition1[i]
        elsif !points_exterieurs_proposition2[i].nil?
            points_exterieurs_retenus[i] = points_exterieurs_proposition2[i]
        else
            points_exterieurs_retenus[i] = 'point pourrave'
        end
    end
    # puts points_exterieurs_retenus
    
    points = []
    points = [points_interieurs_retenus[0], points_interieurs_retenus[1], points_interieurs_retenus[2], points_exterieurs_retenus[0], points_exterieurs_retenus[1], points_exterieurs_retenus[2]]
    plan_vertical = [points[0], points[1], points[4], points[3]] 
    plan_horizontal = [points[1], points[2], points[5], points[4]]
    if !check_corner
        return plan_vertical, plan_horizontal
    else
        plans = project_on_corner(plan_ext, plan_int, vector1, vector2, plan_vertical, plan_horizontal)
        return plans # plan_vertical, plan_horizontal
    end
    
end # def project_points_to_stairwell

end # Class Define_points

    # def pickUp
        # Sketchup.active_model.select_tool Pick.new
        # Sketchup.active_model.select_tool Line Tool
    # end
    # pickUp