# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------
# Name        :   Fastair-i_Shape
# Author      :   Gilles TARNUS
# Contact     :   gta974@gmail.com
# Description :   A script to draw Stair in 4 clicks
# Menu Item   :   2014 to now Extensions->Fastair-i_Shape
#                 until 2014 : Plugins->Fastair-i_Shape
# Usage       :   Select the tool: pick up origin of stair
#                 - pick up origin of stair
#                 - pick up the width of stair
#                 - pick up the depth of stair
#                 - pick up the high depth of stair
# Date        :   10/23/2015
# Type        :   tool
#-----------------------------------------------------------------------------
require 'sketchup.rb'

# Add a menu item to launch our plugin.

# UI.menu("Plugins").add_item("Fastair-i_Shape") {
  # Call function
    def pickUp_i
        Sketchup.active_model.select_tool Pick_i.new
    end
    # pickUp_i
# }
#contantes du modele
	mod = Sketchup.active_model # Open model
	ent = mod.entities # All entities in model
	sel = mod.selection # Current selection
    
#Unité et valeurs d'entree
	if Sketchup.active_model.options["UnitsOptions"]["LengthUnit"] > 1
        $unit = 25.4
    else 
        $unit = 25.4
	end

class Pick_i###

def getExtents
    bbox=Sketchup.active_model.bounds
    bbox.add(@ip.position)if @ip and @ip.valid?
    bbox.add(@ip1.position)if @ip1 and @ip1.valid?
    bbox.add(@ip2.position)if @ip2 and @ip2.valid?
    bbox.add(@ip3.position)if @ip3 and @ip3.valid?
    bbox.add(@ip4.position)if @ip4 and @ip4.valid?
    return bbox
end

def initialize
    @ss = Sketchup.active_model.selection
    @ip1 = nil
    @ip2 = nil
    @ip3 = nil
    @ip4 = nil
    @xdown = 0
    @ydown = 0
end

def activate
    @ip1 = Sketchup::InputPoint.new
    @ip2 = Sketchup::InputPoint.new
    @ip3 = Sketchup::InputPoint.new
    @ip4 = Sketchup::InputPoint.new
    @ip = Sketchup::InputPoint.new
    @drawn = false
    
    self.reset(nil)
end

def deactivate(view)
    view.invalidate if @drawn
end

def onMouseMove(flags, x, y, view)
    if( @state == 0 )
       
        @ip.pick view, x, y
        if( @ip != @ip1 )
            view.invalidate if( @ip.display? or @ip1.display? )
            @ip1.copy! @ip
            view.tooltip = @ip1.tooltip
        end
    elsif( @state == 1 )
        @ip2.pick view, x, y, @ip1
        view.tooltip = @ip2.tooltip if( @ip2.valid? )
        view.invalidate
        
        if( @ip2.valid? )
            length = @ip1.position.distance(@ip2.position)
            Sketchup::set_status_text length.to_s, SB_VCB_VALUE
        end
        
        if( (x-@xdown).abs > 10 || (y-@ydown).abs > 10 )
            @dragging = true
        end
    elsif( @state == 2 )
        @ip3.pick view, x, y, @ip2
        view.tooltip = @ip3.tooltip if( @ip3.valid? )
        view.invalidate
        
        if( @ip3.valid? )
            length = @ip2.position.distance(@ip3.position)
            Sketchup::set_status_text length.to_s, SB_VCB_VALUE
        end
        
        if( (x-@xdown).abs > 10 || (y-@ydown).abs > 10 )
            @dragging = true
        end
    else
        @ip4.pick view, x, y, @ip3
        view.tooltip = @ip4.tooltip if( @ip4.valid? )
        view.invalidate
        
        if( @ip4.valid? )
            length = @ip3.position.distance(@ip4.position)
            Sketchup::set_status_text length.to_s, SB_VCB_VALUE
        end
        
        if( (x-@xdown).abs > 10 || (y-@ydown).abs > 10 )
            @dragging = true
        end
    end
end

def onLButtonDown(flags, x, y, view)
    if( @state == 0 )
        @ip1.pick view, x, y
        if( @ip1.valid? )
            @state = 1
            Sketchup::set_status_text "FaStair: Second Point to define width", SB_PROMPT
            @xdown = x
            @ydown = y
        end
    elsif( @state == 1 )
        # @ip2.pick view, x, y
        if( @ip2.valid? )
            @state = 2
            Sketchup::set_status_text "FaStair: 3th Point to define depth", SB_PROMPT
            @xdown = x
            @ydown = y
        end
    elsif( @state == 2 )
        # @ip2.pick view, x, y
        if( @ip3.valid? )
            @state = 3
            Sketchup::set_status_text "FaStair: 4th Point to define height", SB_PROMPT
            @xdown = x
            @ydown = y
        end
    else
        self.get_pts_i(@ip1.position, @ip2.position, @ip3.position, @ip4.position, view)
        self.reset(view)
    end
    
    view.lock_inference
end

def onKeyDown(key, repeat, flags, view)
    if( key == CONSTRAIN_MODIFIER_KEY && repeat == 1 )
        @shift_down_time = Time.now
        if( view.inference_locked? )
            view.lock_inference
        elsif( @state == 0 && @ip1.valid? )
            view.lock_inference @ip1
        elsif( @state == 1 && @ip2.valid? )
            view.lock_inference @ip2, @ip1
        elsif( @state == 2 && @ip3.valid? )
            view.lock_inference @ip3, @ip2
        elsif( @state == 3 && @ip4.valid? )
            view.lock_inference @ip4, @ip3
        end
    end
end

def onKeyUp(key, repeat, flags, view)
    if( key == CONSTRAIN_MODIFIER_KEY &&
        view.inference_locked? &&
        (Time.now - @shift_down_time) > 0.5 )
        view.lock_inference
    end
end

def draw(view)
    if( @ip1.valid? )
        if( @ip1.display? )
            @ip1.draw(view)
            @drawn = true
            view.draw_points @ip1.position, 8, 1, "black"
        end
        
        if( @ip2.valid? )
            @ip2.draw(view) if( @ip2.display? )
            
            view.set_color_from_line(@ip1, @ip2)
            self.draw_geometry(@ip1.position, @ip2.position, view)
            @drawn = true
        end
        if( @ip3.valid? )
            @ip3.draw(view) if( @ip3.display? )
            
            view.set_color_from_line(@ip2, @ip3)
            self.draw_geometry(@ip2.position, @ip3.position, view)
            @drawn = true
        end
        if( @ip4.valid? )
            @ip4.draw(view) if( @ip4.display? )
            
            view.set_color_from_line(@ip3, @ip4)
            self.draw_geometry(@ip3.position, @ip4.position, view)
            @drawn = true
        end
    end
    view.draw_points @ip2.position, 8, 1, "black"
    view.draw_points @ip3.position, 10, 1, "red"
    view.draw_points @ip4.position, 10, 1, "blue"
end

# onCancel is called when the user hits the escape key
def onCancel(flag, view)
    self.reset(view)
end


# Reset the tool back to its initial state
def reset(view)
    @state = 0
    Sketchup::set_status_text("FaStair: First Point to define origine", SB_PROMPT)
    @ip1.clear
    @ip2.clear
    @ip3.clear
    @ip4.clear
    
    if( view )
        view.tooltip = nil
        view.invalidate if @drawn
    end
    
    @drawn = false
    @dragging = false
end

# Draw the geometry
def draw_geometry(pt1, pt2, view)
    view.draw_line(pt1, pt2)
end

def get_pts_i(p1, p2, p3, p4, view)
    $point1 = Geom::Point3d.new(p1)
    $point2 = Geom::Point3d.new(p2)
    $point3 = Geom::Point3d.new(p3)
    $point4 = Geom::Point3d.new(p4)
    a = Define_points_i.new
end # def get_pts_i

end # Class Pick_i

class Define_points_i###

def initialize
    determination_caracterisques_i
    if @drawn == true 
        dessin_escalier_i
    end
end

def determination_caracterisques_i
    if $point3.z != $point2.z
        vecteur_hauteur_totale = $point3 - $point2
        hauteur_totale = vecteur_hauteur_totale.length
        vecteur_longueur_totale = $point4 - $point3
        longueur_totale = vecteur_longueur_totale.length
        vecteur_largeur = $point2 - $point1
        @largeur = vecteur_largeur.length
    else
        vecteur_hauteur_totale = $point4 - $point3
        hauteur_totale = vecteur_hauteur_totale.length
        vecteur_longueur_totale = $point3 - $point2
        longueur_totale = vecteur_longueur_totale.length
        vecteur_largeur = $point2 - $point1
        @largeur = vecteur_largeur.length       
    end
    
    @nombre_de_marches = 1
    giron_min = 260
    giron_max = 280
    longueur_totale = vecteur_longueur_totale.length - giron_min / $unit
    hauteur_totale = hauteur_totale
    @hauteur_de_marche = hauteur_totale * 25.4 / @nombre_de_marches
        
    # optimisation de la hauteur de marche 
    i = 1
    if hauteur_totale > 2 * 160 / $unit
        @drawn = true
        while ( @hauteur_de_marche > 180 or @hauteur_de_marche < 160 )
            if @hauteur_de_marche > 180
                @nombre_de_marches = @nombre_de_marches + 1
            elsif @hauteur_de_marche < 160 # and @nombre_de_marches > 1
                @nombre_de_marches = @nombre_de_marches - 1
            else
                break
            end
            puts @nombre_de_marches
            @hauteur_de_marche = hauteur_totale * 25.4 / @nombre_de_marches
            i += 1
            if i > 100
                break
            end
        end
    else
        UI.messagebox("Stair is not high enough")
        @drawn = false
    end
    
    # optimisation bipolaire du giron
    longueur_max = @nombre_de_marches * giron_max / $unit
    longueur_min = @nombre_de_marches * giron_min / $unit
    if (longueur_totale - longueur_max).abs < (longueur_totale - longueur_min).abs
        @giron = giron_max
    else
        @giron = giron_min
    end
    
    # Vecteur unitaire :
    vecteur_giron_unitaire = vecteur_longueur_totale.normalize!
    vecteur_largeur_unitaire = vecteur_largeur.normalize!
    vecteur_hauteur_unitaire = vecteur_hauteur_totale.normalize!
    # Vecteur entier :
    @vecteur_giron_entier = vecteur_giron_unitaire
    @vecteur_giron_entier.length = @giron / $unit
    @vecteur_giron_entier = vecteur_giron_unitaire
    @vecteur_giron_entier.length = @giron / $unit
    @vecteur_largeur_entier = vecteur_largeur_unitaire
    @vecteur_largeur_entier.length = @largeur
    @vecteur_largeur_foulee = vecteur_largeur_unitaire
    @vecteur_largeur_foulee.length = @largeur / 2
    @vecteur_hauteur_entier = vecteur_hauteur_unitaire
    @vecteur_hauteur_entier.length = @hauteur_de_marche / $unit
    # Plans limites
    @plan_gauche = [$point1, vecteur_largeur_unitaire]
    @plan_droit = [$point2, vecteur_largeur_unitaire.reverse]
    
end # def determination_caracterisques_i

def dessin_escalier_i
    # Creation des points / faces et du groupe
        pt0 = Geom::Point3d.new
        # pt0 = $point1.offset @vecteur_giron_entier.reverse
        # pt0 = $point1.offset @vecteur_largeur_foulee
        
        decalage =  @vecteur_giron_entier.reverse +  @vecteur_largeur_foulee
        pt0 = $point1.offset @vecteur_largeur_foulee
        @stair = Sketchup.active_model.entities.add_group
        @stair_line = Sketchup.active_model.entities.add_group
        for i in 1..@nombre_de_marches
        pt1 = pt0.offset @vecteur_hauteur_entier 
        pt2 = pt1.offset @vecteur_giron_entier
        # pt_v1 = pt0.project_to_plane @plan_gauche
        pt_v1 = project_to_plane_from_vector_i(pt0, @vecteur_largeur_foulee, @plan_gauche)
        # pt_v2 = pt0.project_to_plane @plan_droit
        pt_v2 = project_to_plane_from_vector_i(pt0, @vecteur_largeur_foulee, @plan_droit)
        pt_v3 = pt1.project_to_plane @plan_droit
        pt_v4 = pt1.project_to_plane @plan_gauche
        pt_h1 = pt1.project_to_plane @plan_gauche
        pt_h2 = pt1.project_to_plane @plan_droit
        pt_h3 = pt2.project_to_plane @plan_droit
        pt_h4 = pt2.project_to_plane @plan_gauche
        # pts_horizontaux = [ pt0.project_to_plane @plan_gauche, pt1.project_to_plane @plan_droit, pt1.project_to_plane @plan_droit, pt1.project_to_plane @plan_gauche]
        pts_verticaux = []
        # pts_horizontaux = [pt0]
            if i != @nombre_de_marches
                # @stair_line.entities.add_line pt0, pt1
                # @stair_line.entities.add_line pt1, pt2
                # @stair.entities.add_face pts_horizontaux[0], pts_horizontaux[1], pts_horizontaux[2], pts_horizontaux[3], 
                @stair.entities.add_face pt_h1 , pt_h2 , pt_h3, pt_h4
                @stair.entities.add_face pt_v1 , pt_v2 , pt_v3, pt_v4
            else
                # @stair_line.entities.add_line pt0, pt1
                @stair.entities.add_face pt_v1 , pt_v2 , pt_v3, pt_v4
            end
        pt0.offset! @vecteur_hauteur_entier
        pt0.offset! @vecteur_giron_entier
        end
end # def dessin_escalier_i

def project_to_plane_from_vector_i(point, vector, plane)
    """Cette fonction projete un point sur un plan
    le long d un vecteur, n existe pas en natif"""
    distance = point.distance_to_plane plane
    vector_unitaire = vector.normalize
    vector_offset = vector_unitaire
    vector_offset.length = distance
    point_projected = point.offset vector_offset
    status = point_projected.on_plane? plane
    # puts status
    if status == false
        vector_offset.length = - distance
        point_projected = point.offset vector_offset
        # puts "reverse"
    end
    status = point_projected.on_plane? plane
        if status == false
            UI.messagebox("Probleme de projection parallele")
        end
    # status = point_projected.on_plane? plane
    # puts status
    return point_projected
end

end # Class Define_points_i